# affiliations-rnsr

L'instance `affiliations-rnsr` utilise l'application ezmaster
[`lodex-workers`](https://github.com/Inist-CNRS/lodex-workers).

Elle offre un service qui déduit de l'adresse d'une affiliation d'auteur et
d'une date de publication (l'année suffit) zéro, un ou plusieurs identifiants
RNSR (correspondant à une ou plusieurs structures de recherche française(s)).

Cet appariement suit des [règles
certaines](https://github.com/Inist-CNRS/ezs/blob/master/packages/conditor/README.md#r%C3%A8gles-certaines).

## Configuration

Il faut préciser dans le fichier de configuration de l'instance qu'elle utilise des paquets nodes:

- `@ezs/basics`
- `@ezs/conditor`

Bien sûr, les dernières versions sont préférables.

Exemple:

```json
{
    "packages": [
        "@ezs/basics@1.13.2",
        "@ezs/conditor@2.2.2"
    ]
}
```

## Utilisation

### v1/csv

Prend un fichier CSV, avec des colonnes nommées `Adresse` et `Année`, et renvoie
un CSV avec la colonne supplémentaire `RNSR`.

Les colonnes doivent être séparées par des tabulations, des points-virgules ou
des virgules.

### Exemple CSV

```bash
cat <<EOF | curl -X POST --data-binary @- "https://affiliations-rnsr.services.inist.fr/v1/csv"
Année,Adresse
2015,CNRS UMR AMAP MONTPELLIER FRA
2015,IRD UMR AMAP MONTPELLIER FRA
2015,"University of Bordeaux, IMS, CNRS UMR5218, Talence, F-33405, France"
2015,"CENBG, CNRS/IN2P3, Chemin du Solarium B. P. 120, Gradignan, F-33175, France"
EOF
```

Sortie:

```csv
Année;Adresse;RNSR
2015;CNRS UMR AMAP MONTPELLIER FRA;200317641S
2015;IRD UMR AMAP MONTPELLIER FRA;200317641S
2015;University of Bordeaux, IMS, CNRS UMR5218, Talence, F-33405, France;200711887V
2015;CENBG, CNRS/IN2P3, Chemin du Solarium B. P. 120, Gradignan, F-33175, France;199512079F
```
